unit uMinSort;

{ **************************************************************************** }
{ **************************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;
   
type
  TForm1 = class(TForm)
    PnlUeberschrift: TPanel;
    LstBoxUnsortiert: TListBox;
    LstBoxSortiert: TListBox;
    LblUnsortiert: TLabel;
    LblSortiert: TLabel;
    BitBtnErzeugen: TBitBtn;
    BitBtnMinSort: TBitBtn;
    BitBtnInformation: TBitBtn;
    BitBtnSchliessen: TBitBtn;
    procedure BitBtnErzeugenClick(Sender: TObject);
    procedure BitBtnMinSortClick(Sender: TObject);
    procedure BitBtnInformationClick(Sender: TObject);
    procedure BitBtnSchliessenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MinSort;
  private
    { Private-Deklarationen }
    Feld: array of Integer;  { Feld fuer Zufallszahlen; Vorsicht: dyn. Array, d.h. Indizes von 0 bis FELDGROESSE-1! }
  public
    { Public-Deklarationen }
  end;

const
  FELDGROESSE = 10;     { Anzahl der Elemente des dyn. Arrays }
  ZAHLENBEREICH = 100;  { Zufallszahlenbereich (von 1) bis 100 }

var
  Form1: TForm1;                   

{ **************************************************************************** }
{ **************************************************************************** }

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Zufallszahlengenerator aktivieren }
  Randomize;

  { Feldlaenge gemaess Konstantenwert festlegen }
  SetLength(Feld,FELDGROESSE);  { Laenge FELDGROESSE festlegen mit Indizes von 0 bis FELDGROESSE - 1 }
end;

{ **************************************************************************** }

procedure TForm1.BitBtnErzeugenClick(Sender: TObject);
var
  i: Integer;
begin
  { Buttons konfigurieren }
  BitBtnErzeugen.Enabled := False;
  BitBtnMinSort.Enabled := True;

  { Reinitialisierungen }
  LstBoxUnsortiert.Clear;
  LstBoxSortiert.Clear;     

  { Zufallszahlen erzeugen, ... }
  for i := 0 to FELDGROESSE - 1 do begin
    { in Array speichern... }
    Feld[i] := Random(ZAHLENBEREICH) + 1;

    { und in ListBox ausgeben. }
    LstBoxUnsortiert.Items.Add(IntToStr(Feld[i]));
  end;
end;

{ **************************************************************************** }

procedure TForm1.MinSort;
var
  i,j     : Integer;  { Zaehlvariablen }
  Temp,Min: Integer;  { Zwischenspeicher, Arrayindex in dem der Minimumwert steht }
begin
  { Gehe das Array durch (letzter Arrayindex nicht noetig, da dessen Inhalt logischerweise automatisch sortiert sein wird, daher "-1") }
  for i := 0 to High(Feld) - 1 do begin  { High liefert (Nummer vom) hoechsten Arrayindex }
    { Annahme: Gehe zu Beginn davon aus, dass im ersten Arrayindex der Minimumwert steht }
    Min := i;
    { Gehe nun vom naechsten Arrayindex erneut das Array durch und... }
    for j := i + 1 to High(Feld) do
      { ...speichere den Arrayindex eines evtl. vorhandenen kleineren Arrayindex-Inhalts in Min. }
      if Feld[j] < Feld[Min] then Min := j;
    { Nun ist der kleinste Arrayindex-Inhalt des Durchlaufs gefunden (Feld[Min]). Vertausche Feld[Min] mit Feld[i]. }
    Temp := Feld[Min];     { Vertausche, Schritt 1: Wert 1 zwischenspeichern }
    Feld[Min] := Feld[i];  { Vertausche, Schritt 2: Wert 2 in Wert 1 schreiben }
    Feld[i] := Temp;       { Vertausche, Schritt 3: Zwischengespeicherten Wert 1 in Wert 2 schreiben }
  end;
end;

{ **************************************************************************** }

procedure TForm1.BitBtnMinSortClick(Sender: TObject);
var
  i: Integer;
begin
  { Buttons konfigurieren }
  BitBtnErzeugen.Enabled := True;
  BitBtnMinSort.Enabled := False;

  { Sortieren }
  MinSort;

  { Ausgabe sortierte Liste }
  for i := 0 to FELDGROESSE - 1 do
    LstBoxSortiert.Items.Add(IntToStr(Feld[i]));
end;

{ **************************************************************************** }

procedure TForm1.BitBtnInformationClick(Sender: TObject);
begin
  { Nachrichtendialog anzeigen }
  MessageDlg('MinSort (V1.0)' + #13 + 'Demonstrationsprogramm zum MinSort-Sortieralgorithmus.' + #13 + #13 +
    'M. Zirbes, 2010' + #13 + #13 +
    'Bei diesem Programm handelt es sich um Freeware,' + #13 +
    'd.h. es steht zur kostenlosen Nutzung frei zur Verfgung' + #13 +
    'und darf ohne Entgelt vervielfltigt und verbreitet werden.' + #13 + #13 +
    'Kontakt: schule@mijozi.de',mtInformation,[mbOK],0);
end;

{ **************************************************************************** }

procedure TForm1.BitBtnSchliessenClick(Sender: TObject);
begin
  Close;
end;

{ **************************************************************************** }
{ **************************************************************************** }

end.
